
DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/sauge/code/progress/ds/queue/tstque.p,v 1.1 2001/11/17 06:35:51 sauge Exp sauge $" NO-UNDO.


{MakeID2.i}
{queue/queue.i}

DEF VAR lResultCode   AS LOGICAL NO-UNDO.
DEF VAR cReturnCode   AS CHARACTER NO-UNDO.
DEF VAR cData         AS CHARACTER NO-UNDO.

OUTPUT TO ./testque.data.

PUT UNFORMATTED "Running Test~n".

/* Clear the Queue */

RUN TestClearQueue.

/* Is the Queue empty? */

RUN TestQueueEmpty.

/* Push some items on the Queue */

RUN TestEnque (INPUT "1").
RUN TestEnque (INPUT "2").
RUN TestEnque (INPUT "3").

/* Is the Queue empty? */

RUN TestQueueEmpty.

/* Pop some items off the Queue */

RUN TestRead.
RUN TestDeque.
RUN TestDeque.
RUN TestDeque.

/* Is the Queue empty? */

RUN TestQueueEmpty.

/* Pull an error */

RUN TestDeque.

OUTPUT CLOSE.

/******************************************************************/
/*            Wrap around error handling and messages             */
/******************************************************************/

PROCEDURE TestQueueEmpty:

  ASSIGN lResultCode = QueEmpty(INPUT "Test", OUTPUT cReturnCode).
  
  IF lResultCode THEN
    PUT UNFORMATTED "Call to QueEmpty Errored!~n".
  ELSE
    PUT UNFORMATTED "Call to QueEmpty Successful~n".
  
  IF cReturnCode = "2" THEN
    PUT UNFORMATTED "Queue Empty~n".
  ELSE
    PUT UNFORMATTED "Queue Populated~n".

END.

PROCEDURE TestEnque:

  DEF INPUT PARAMETER pValue AS CHARACTER NO-UNDO.

  lResultCode = QueEnque(INPUT "Test", INPUT pValue, OUTPUT cReturnCode).
  
  IF lResultCode THEN DO:
    PUT UNFORMATTED "An Error occurred calling QueEnque.~n".
    PUT UNFORMATTED "Error is: " cReturnCode "~n".
  END.
  ELSE
    PUT UNFORMATTED "No Error occurred calling QueEnque.~n".

END.

PROCEDURE TestDeque:

  DEF VAR pValue AS CHARACTER NO-UNDO.

  lResultCode = QueDeque(INPUT "Test", OUTPUT pValue, OUTPUT cReturnCode).

  IF lResultCode THEN DO:
    PUT UNFORMATTED "An Error occurred calling QueDeque.~n".
    PUT UNFORMATTED "Error is: " cReturnCode "~n".
  END.
  ELSE DO:
    PUT UNFORMATTED "No Error occurred calling QueDeque.~n".
    PUT UNFORMATTED "Value is " pValue "~n".
  END.

END.

PROCEDURE TestRead:

  DEF VAR pValue AS CHARACTER NO-UNDO.

  lResultCode = QueRead(INPUT "Test", OUTPUT pValue, OUTPUT cReturnCode).

  IF lResultCode THEN DO:
    PUT UNFORMATTED "An Error occurred calling QueRead.~n".
    PUT UNFORMATTED "Error is: " cReturnCode "~n".
  END.
  ELSE DO:
    PUT UNFORMATTED "No Error occurred calling QueRead.~n".
    PUT UNFORMATTED "Value is " pValue "~n".
  END.

END.

PROCEDURE TestClearQueue:

  lResultCode = QueClear(INPUT "Test", OUTPUT cReturnCode).

  IF lResultCode THEN DO:
    PUT UNFORMATTED "An Error occurred calling QueClear.~n".
    PUT UNFORMATTED "Error is: " cReturnCode "~n".
  END.
  ELSE
    PUT UNFORMATTED "No Error occurred calling QueClear.~n".

END.


